#ifndef __MFDGLOBALS_H
#define __MFDGLOBALS_H


// Needed due to the implementation of the selection functions in Orbiter
bool SelectMajorbody(void*id, char *str, void *usrdata);
bool SelectMinorbody(void*id, char *str, void *usrdata);
bool SelectTargetbody(void*id, char *str, void *usrdata);
bool ConfirmReset(void *id, char *str, void *usrdata);
bool SelectVariableBody(void *id, char *str, void *usrdata);

double dotproduct(VECTOR3 vector1, VECTOR3 vector2);
VECTOR3 crossproduct(VECTOR3 vector1, VECTOR3 vector2);
VECTOR3 unitise(VECTOR3 vector);
double vectorsize(VECTOR3 vector);
void matrixmultiply(MATRIX3 &first, MATRIX3 &second, MATRIX3 *result);
void matrixmultiply(MATRIX3 &first, VECTOR3 &second, VECTOR3 *result);
void getinvrotmatrix(VECTOR3 arot, MATRIX3 *invrotmatrix);


// Standard formatting function
void TextShow(HDC hDC, const char *label, int wpos, int hpos, double value);


const double GRAVITY=6.67255926e-11; // Gravitational constant

static double debug=0;

#endif