#ifndef __MFDVARHANDLER_H
#define __MFDVARHANDLER_H

#include "mfdvartypes.h"

#define MAXVIEWMODES 10
#define MAXPOINTERS 30

class MFDvarhandler{
private:
	MFDvariable *pointers[MAXPOINTERS];// Arbitrary array sizes - any answer?
	int startvarpointer[MAXVIEWMODES]; // Holds starts for mode position and number of variables
	int endvarpointer[MAXVIEWMODES];//And ends
	int currvariable; //The current variable
	int lastvariable; //The last legal variable in the set
public:
	void setviewrange(int viewmode, int start, int end);
	void setprevcurrent(int viewmode);
	void setnextcurrent(int viewmode);
	void saveallvariables(FILEHANDLE scn);
	bool loadallvariables(FILEHANDLE scn);
	MFDvariable* getcurrent(int viewmode);
	MFDvarhandler();//Sets MFDvariable list to 0
	~MFDvarhandler();//Deletes all MFDvariables created through the class
	void deleteall(); // Deletes and resets MFD variable system - typically following inability to assign space
	void resetvars();
	int getlastvariable() const; //returns lastvariable
	MFDvariable *getpointer(int index) const;//returns pointer to base class
	double getvalue(int index) const;// next 5 equivalent to call via pointer to MFDvariable
	void getsincos(int index, double *sin, double *cos) const;
	double getsin(int index) const;
	double getcos(int index) const;
	OBJHANDLE gethandle(int index) const;
	int getivalue(int index) const;
	void setvalue(int index, double tvalue) const;
	void setivalue(int index, int tvalue) const;
	void sethandle(int index, OBJHANDLE thandle) const;
	void gethelpstrings(int index, char *help1, char *help2);
	void sethelpstrings(int index, char *help1, char *help2);
	bool newvarfloat(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);// Constructs, but also adds pointer to list
	bool newvarangle(char *vname, int vadjmode, double vvalue, double vcosvalue, double vsinvalue, double vmin, double vmax, double vincrement, bool vloop);// Ditto
	bool newvardiscrete(char *vname, int vvalue, int vlimit, char *st1, char *st2, char *st3, char *st4, char *st5);// Ditto
	bool newvarbody(char *vname, char *vlabel);//Ditto
	bool newvarMJD(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);//Ditto
};

#endif