#ifndef __NavigateMFD_H
#define __NavigateMFD_H



// Class encapsulating the definition and manipulation of orbital paramenters
// Presently very public - may not stay so
// These elements are not intended to be the minimum description of the orbit - they provide convenient
// access to quantities I can use to calculate what I want.

/*typedef class orbitelements{
private:
	VECTOR3 planevector; // Vector perpendicular to plane - defines orbital plane
	double angularmomentum2; // Angular momentum squared
	double semimajor; // Length of semi-major axis - NEGATIVE if elliptical, POSITIVE if hyperbolic
	VECTOR3 eccvector; // Eccentricity vector
	double eccentricity; // eccentricity of orbit
	double currcosthi; // cosine of angle of craft from periapsis
	double currsinthi; //sin of angle of craft from periapsis
	double timestamp; //Simtime when orbit snapshot taken
	VECTOR3 majoraxis; // Unit vector along major axis towards periapsis
	VECTOR3 minoraxis; // Unit vector along minor axis towards outward side of orbit
	VECTOR3 currposition; // Current position on orbit
	VECTOR3 currvelocity; // Current velocity on orbit
	double planet; // GM for planet
	double deltatime;  // Time from current position to Periapsis
	bool valid; //Whether the orbit class is valid or not
public:
	orbitelements(); // Default constructor
	orbitelements(OBJHANDLE hmajor, OBJHANDLE hminor); //Constructor
	orbitelements(VECTOR3 rposition, VECTOR3 rvelocity, double gmplanet); //Constructor using pos and vel vectors
	init(OBJHANDLE hmajor, OBJHANDLE hminor);//Initialiser
	init(const VECTOR3 &rposition, const VECTOR3 &rvelocity, double gmplanet); //Initialiser using pos and vel vectors
	init(const VECTOR3 &rposition, const VECTOR3 &rvelocity, double ttimestamp, double gmplanet); //Initialiser that pushes out a timestamp as well
	void draworbit(HDC hDC, const class graphset *graph, bool drawradius) const; //Draws an orbit in window and projection described in graph
	//Can be called even if orbit.isvalid() is false

	//The routines below generally ASSUME that orbit has been initialised
	double GetTimeToThi(double costhi, double sinthi) const; //Gets time from present position to the angle thi. Bit ratty for hyperbolics
	double GetTimeToRadius(double radius, bool outward) const; //Gets time from present position to the radius given
	void vectortothi(const VECTOR3 &vector,double *costhi,double *sinthi) const; //Gets closest costhi and sinthi from vector angle (NOT from length)
	double thitoradius(double costhi) const; //cos thi to radius
	double radiustothi(double radius) const; //radius to cos thi
	void GetTimesToThi(double costhi, double *time1, double *time2) const; //Gets time from present position to a given costhi (both + and - solutions)
	void thitovectors(double costhi, double sinthi, VECTOR3 *position, VECTOR3 *velocity) const; //Angle thi from periapsis to pos and vel
	void radiustovectors(double radius, bool outward, VECTOR3 *position, VECTOR3 *velocity) const; // Now works from radius length too - should always go from known information
	void timetovectors(double timefromnow, VECTOR3 *pos, VECTOR3 *vel) const;//Time from present to pos and vel vectors
	void minortomajor(const class orbitelements &rmininrmaj, class orbitelements *rmajorbit, double soisize) const; //Finds path from hyperbolic orbit around present body to orbit around rmaj
	double geteccentricity() const; //Parameter retrieving routines
	double getangmomentum2() const;
	double getcurrcosthi() const;
	double getcurrsinthi() const;
	void getaxes(VECTOR3 *tmajoraxis, VECTOR3 *tminoraxis) const; //Major and minor axes
	void getcurrentvectors(VECTOR3 *tpos, VECTOR3 *tvel) const; //vectors when orbit defined
	double getsemimajor() const;
	VECTOR3 geteccentricityvector() const;
	VECTOR3 getplanevector() const;
	double gettimestamp() const;
	double getpedeltatime() const;
	bool isvalid() const;//Says whether this structure has been initialised properly
	double getgmplanet() const;//mass of central body * GRAVITY
	double getcurrradius() const;
	double getpedistance() const;
	double getapodistance() const;
	VECTOR3 getintersectvector(const class orbitelements &torbit) const;//vector along line of intersection of two orbits (like align MFD)
} ORBIT;*/

/*
typedef class intercept{
	private:
		double iceptradius;
		double icepttimeoffset;
		int iceptmethod;
		VECTOR3 iceptalpha;
		VECTOR3 iceptbeta;
		bool newintercept;
		VECTOR3 icraftpos;
		VECTOR3 icraftvel;
		VECTOR3 itargetpos;
		VECTOR3 itargetvel;
		VECTOR3 iplanecept;
		double itimeintercept;
	public:
		intercept(); //Default constructor
		void updateintercept(const ORBIT &craft, const ORBIT &target);
		void resetintercept();
		void getpositions(VECTOR3 *craftpos, VECTOR3 *targetpos) const;
		void getvelocities(VECTOR3 *craftvel, VECTOR3 *targetvel) const;
		void getrelpos(VECTOR3 *relpos) const;
		void getrelvel(VECTOR3 *relvel) const;
		void getplanecept(VECTOR3 *planecept) const;
		double gettimeintercept() const;
} INTERCEPT;

*/

/*
class MFDvariable {
protected:
	char name[20]; //Name of variable as displayed on MFD
	int adjmode; // Integer representing the adjustment mode - use depends on class
public:
	virtual ~MFDvariable();
	void showadjustment(HDC hDC, int width, int line) const; //Show the adjustment mode
	void ch_adjmode(); // Change the adjustment mode
	int getadjmode() const; //Get the current adjustment mode
	// Following three implemented to do nothing much - designed to overload
	virtual bool inc_variable(); //Increase the variable
	virtual bool dec_variable(); //Decrease the variable
	virtual bool flip_variable(); // Change the variable in discrete amounts
	virtual bool show(HDC hDC, int width, int line) const;
	virtual double getvalue() const; // Virtual functions for data access - implemented as safety values here
	virtual int getivalue() const;
	virtual void getsincos(double *sin, double *cos) const;
	virtual double getsin() const;
	virtual double getcos() const;
	virtual void setvalue(double tvalue);
	virtual void setivalue(int tvalue);
	virtual void sethandle(OBJHANDLE tpointer);
	virtual OBJHANDLE gethandle() const;
};
*/
/*
class MFDvarbody : public MFDvariable {
protected:
	OBJHANDLE pointer;
	char label[40];
public:
	MFDvarbody(char *vname, char *vlabel);
	~MFDvarbody();
	void sethandle(OBJHANDLE tpointer);
	OBJHANDLE gethandle() const;
	bool flip_variable();
	bool SetVariableBody(char *str);
	virtual bool show(HDC hDC, int width, int line) const;
};
*/

/*
class MFDvarhandler{
private:
	MFDvariable *pointers[30];
	int lastvariable;
public:
	MFDvarhandler();//Sets MFDvariable list to 0
	~MFDvarhandler();//Deletes all MFDvariables created through the class
	void deleteall(); // Deletes and resets MFD variable system - typically following inability to assign space
	int getlastvariable() const; //returns lastvariable
	MFDvariable *getpointer(int index) const;//returns pointer to base class
	double getvalue(int index) const;// next 5 equivalent to call via pointer to MFDvariable
	void getsincos(int index, double *sin, double *cos) const;
	double getsin(int index) const;
	double getcos(int index) const;
	OBJHANDLE gethandle(int index) const;
	int getivalue(int index) const;
	void setvalue(int index, double tvalue) const;
	void setivalue(int index, int tvalue) const;
	void sethandle(int index, OBJHANDLE thandle) const;
	bool newvarfloat(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);// Constructs, but also adds pointer to list
	bool newvarangle(char *vname, int vadjmode, double vvalue, double vcosvalue, double vsinvalue, double vmin, double vmax, double vincrement, bool vloop);// Ditto
	bool newvardiscrete(char *vname, int vvalue, int vlimit, char *st1, char *st2, char *st3, char *st4, char *st5);// Ditto
	bool newvarbody(char *vname, char *vlabel);//Ditto
	bool newvarMJD(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);//Ditto
};
*/

/*
class MFDvarfloat : public MFDvariable {
protected:
	double value; // Value of the variable
	double min; // Minimum legal value
	double max; //Maximum legal value
	double increment; //Increment fraction
	double logborder; // Number below which increment is linear scaled
public:
	bool inc_variable(); // Increase the variable
	bool dec_variable(); //Decrease the variable
	bool show(HDC hDC, int width, int line) const;
	double getvalue() const; //Get the value
	void setvalue(double tvalue);
	MFDvarfloat(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);
	~MFDvarfloat();
};

class MFDvarMJD: public MFDvarfloat {
public:
	bool show(HDC hDC, int width, int line) const;
	MFDvarMJD(char *vname, int vadjmode, double vvalue, double vmin, double vmax, double vincrement, double vlogborder);
	~MFDvarMJD();
};


class MFDvardiscrete: public MFDvariable {
private:
	char label[5][15]; //Label array
	int value; // Variable indicating the projection type
	int limit; // Highest permissible value - Note - 5 labels MAX!!
public:
	bool flip_variable(); //Change to next projection
	int getivalue() const; // Function to obtain value
	void setivalue(int tvalue);
	bool show(HDC hDC, int width, int line) const;
	MFDvardiscrete(char *vname, int vvalue, int vlimit, char *st1, char *st2, char *st3, char *st4, char *st5);
	~MFDvardiscrete();
};

class MFDvarangle: public MFDvariable {
private:
	double value; // Value of the angle
	double cosvalue;//Cosine of the angle - calculated here to avoid repeated recalculation later
	double sinvalue; //Sin of the angle - as above
	double min; // Minimum legal value
	double max; // Maximum legal value
	double increment; // Increment value
	bool loop; //If true, then loops from min to max
public:
	bool inc_variable(); //Increase the variable
	bool dec_variable(); //Decrease the variable
	bool show(HDC hDC, int width, int line) const;
	double getvalue() const;
	void setvalue(double tvalue);
	void getsincos(double *sin, double *cos) const;
	double getsin() const;
	double getcos() const;
	MFDvarangle(char *vname, int vadjmode, double vvalue, double vcosvalue, double vsinvalue, double vmin,
		double vmax, double vincrement, bool vloop);
	~MFDvarangle();
};
*/

/*
// Needed due to the implementation of the selection functions in Orbiter
bool SelectMajorbody(void*id, char *str, void *usrdata);
bool SelectMinorbody(void*id, char *str, void *usrdata);
bool SelectTargetbody(void*id, char *str, void *usrdata);
bool ConfirmReset(void *id, char *str, void *usrdata);
bool SelectVariableBody(void *id, char *str, void *usrdata);


// Needed vector functions not defined in orbitersdk.h

double dotproduct(VECTOR3 vector1, VECTOR3 vector2);
VECTOR3 crossproduct(VECTOR3 vector1, VECTOR3 vector2);
VECTOR3 unitise(VECTOR3 vector);
double vectorsize(VECTOR3 vector);
void matrixmultiply(MATRIX3 &first, MATRIX3 &second, MATRIX3 *result);
void matrixmultiply(MATRIX3 &first, VECTOR3 &second, VECTOR3 *result);
void getinvrotmatrix(VECTOR3 arot, MATRIX3 *invrotmatrix);





// Standard formatting function
void TextShow(HDC hDC, const char *label, int wpos, int hpos, double value);
*/

/*
typedef class graphset{
//This class holds information on a display window for graphs, and vectors for the projection angle of these
//orbit graphs, and current scaling
friend class orbitelements;
public:
	void drawvector(HDC hDC, const VECTOR3 &line);//Draws vector line at current projection & scaling
	void drawplanet(HDC hDC, OBJHANDLE body); //Draw circle representing planet
	void setprojection(const ORBIT &torbit);//View set from orbit's plane vector
	void setprojection(const VECTOR3 &projection);// View set from vector
	void setprojection(const VECTOR3 &txaxis, const VECTOR3 &tyaxis, const VECTOR3 &tzaxis);//Explicitly set axes
	void drawtwovector(HDC hDC, const VECTOR3 &line1, const VECTOR3 &line2);//Draw two vectors using current projection & scaling
	void draworbit(const ORBIT &element, HDC hDC, bool drawradius);//Calls draworbit in orbitelements
	double vectorpointdisplay(HDC hDC, const VECTOR3 &target, MFD *mfd, VESSEL *vessel, bool isposition);//Nice little pointer utility
	//void init(DWORD w, DWORD h);
	void setviewscale(const ORBIT &orbit);//Set scale of picture using orbit size
	void setviewscale(double temp);//Set scale using a number
	void setviewscalesize(double temp);//Set scale using a distance size
	void setviewwindow(DWORD xstart, DWORD ystart, DWORD xend, DWORD yend);//Set a window within MFD
	void getviewwindow(DWORD *xstart, DWORD *ystart, DWORD *xend, DWORD *yend);//Get back above info
	double getviewscale();//Get viewscale number
private:
	VECTOR3 xaxis, yaxis, zaxis; // projection vectors
	DWORD ixstart, iystart, ixend, iyend, windowsize;//window parameters
	double scale;//scaling factor for diagram
}GRAPH;
*/

/*
class NavigateMFD: public MFD {
public:
	NavigateMFD (DWORD w, DWORD h, VESSEL *Vessel, class navmfdstate *tstate);
	char *ButtonLabel (int bt);
	int  ButtonMenu (const MFDBUTTONMENU **menu) const;
	bool ConsumeKeyImmediate(char *kstate);
	bool ConsumeButton(int bt, int event);
	bool ConsumeKeyBuffered(DWORD key);
	void Update (HDC hDC);
	bool SetResetflag(char *str);
	void resetvars();

	bool SetMajorBody(char *str); //Sets major body to str
	bool SetMinorBody(char *str); //Sets minor body to str
	bool SetTargetBody(char *str); //Sets target body to str
	static int MsgProc (UINT msg, UINT mfd, WPARAM wparam, LPARAM lparam);
private:
	GRAPH graph, graphleft, graphright;
	bool updateinterception(const ORBIT &hypormaj, const ORBIT &craftinrmaj, const ORBIT &majtarget, bool h_or_c);
	void doupdate(HDC hDC);
	void mode0update(HDC hDC);
	void mode1update(HDC hDC);
	void mode2update(HDC hDC);
	void mode3update(HDC hDC);
	void showminorsoiview2(HDC hDC, GRAPH *locgraph, const ORBIT &rmin, const ORBIT &craftinrmaj, const ORBIT &hypormaj, const ORBIT &majtarget, double ejectmjd, bool hypoorcraft, bool showintercept, int majprojection, int majvieworb, bool showrinc);
	bool encounter (HDC hDC,OBJHANDLE hobject, OBJHANDLE satellitebodyhandle, INTERCEPT *intercept, DWORD pencolour);
	bool initialisemode1vars();
	bool initialisemode2vars();
	bool initialisemode3vars();
	bool minormodevalidate(HDC hDC, const VECTOR3 &gminor, const VECTOR3 &gcraftpos, double soisize2, const char *modelabel,int nonvalidmfdstate);
	void Getmode1hypo(ORBIT *hypormin, ORBIT *hypormaj, ORBIT &rmin, double gmmajor, double soisize2, double *timetoeject);
	void Getmode2hypo(ORBIT *hypormaj, VECTOR3 *targetvel, const ORBIT &baseorbit);
	void Getmode3hypo(ORBIT *hypormin, ORBIT *hypormaj, VECTOR3 *ejectvector, ORBIT &rmin, ORBIT &craftinrmin, double gmminor, double soisize2, bool *goodcrab, double *ejectmjd);
	void showminorsoiview1(HDC hDC, GRAPH *locgraph, const ORBIT &rmin, const ORBIT &hypormin, int minprojection, int minvieworb,bool showrinc);
	void memerror(); // Recovers from inability to assign MFDvariable

	class navmfdstate *state;// Pointer to state information
	class MFDvarhandler *vars; //Variable handler
	class MFDvariable *varpointer; //Pointer to MFDvariable
	INTERCEPT *primary; //Pointer to the primary intercept engine
	DWORD linespacing;
	bool resetallvariables;
	double simstartMJD; //MJD of simtime=0
};
*/
/*
class navmfdstate {
public:
	navmfdstate(UINT mfd);
	~navmfdstate();
	OBJHANDLE hmajor; // Handle for major body
	OBJHANDLE hcraft; // Handle for craft
	OBJHANDLE hminor; // Handle for minor body
	OBJHANDLE basehandle; //Handle for surface base
	OBJHANDLE hmajtarget; // Handle for target in orbit around major body
	double gravbodyratio;//Not a straight ratio - factor for calculating radius of sphere of influence
	int startvarpointer[10]; // Holds starts for mode position and number of variables
	int endvarpointer[10];//And ends
	int numbervariables;
	int currvariable;// index of current MFDvariable
	bool var;//Specified whether a variable is to be displayed or not
	int getmfdstate() const; // state of MFD - currently 0,1,2 - do NOT match viewmodes
	void setmfdstate(int tmfd);
	void setmfdstateinitialised(int tmfd);
	bool mfdstateinitialised() const;
	bool mfdstatevalidated; //True if current mode can be processed. Is always true if MFD switches mode automatically
							//Is initially false after human mode switch. Prevents MFD autoswitching modes when user changes mode
	int viewmode; //viewmode of MFD 
	int numberviews; //Number of allowed views for the current mfdstate
	class MFDvarhandler vars;//Storage held here
	ORBIT basisorbit; //Orbit on which manoevres within the MFD are based
	double basisorbittime;
	double fnchangetime;//Time when main MFD function last changed
	INTERCEPT primary; //Primary interception computation engine
	static bool getnavmfdstate(UINT mfd, class navmfdstate **state); //get existing navmfdstate
	static bool newnavmfdstate(UINT mfd, class navmfdstate **state); //Create new navmfdstate
	static void deleteallnavmfdstate(); //Delete all navmfdstate objects
	static void updatefocusvessel(OBJHANDLE newfocus); //Updates handles when vessel changes
	bool initflag;
private:
	UINT mfdid;
	int mfdstate;
	int lastinitialisedmfdstate;
	static navmfdstate *mfdstatelist[5];//List of up to 5 navmfdstates
};

*/

double debug;

#endif //!__NavigateMFD_H