#ifndef __TRANSXSTATE_H
#define __TRANSXSTATE_H

#define NUMFUNCTIONS 4

class transxstate {
public:
	transxstate(UINT mfd,class TransxMFD *tmfdpointer);
	~transxstate();

	//To stay
	bool isvalid(){return valid;};
	int getmfdstate() const; // function in use - currently 1,2,3
	void setmfdstate(int tmfd);
	//void setmfdstateinitialised(int tmfd);
	void doupdate(HDC hDC,int tw, int th, class TransxMFD *tmfdpointer);
	void savecurrent(FILEHANDLE scn);
	void restoresave(FILEHANDLE scn);

	class TransxMFD *GetMFDpointer();//Returns pointer to current MFD
	class TransXFunction *GetCurrFunction(); //Returns the current function
	class MFDvarhandler *GetVarhandler(); //Gets the variable handler for the current function
	class MFDvariable *GetCurrVariable(); //Gets the current variable in the current function
	bool mfdstatevalidated; //True if current mode can be processed. Is always true if MFD switches mode automatically
							//Is initially false after human mode switch. Prevents MFD autoswitching modes when user changes mode
	static bool gettransxstate(UINT mfd, class transxstate **state, TransxMFD *tmfdpointer); //get existing transxstate
	static bool newtransxstate(UINT mfd, class transxstate **state, TransxMFD *tmfdpointer);//Create new transxstate
	static void deletealltransxstate(); //Delete all transxstate objects
	static void updatefocusvessel(OBJHANDLE newfocus); //Updates handles when vessel changes
	void updateownfocusvessel(OBJHANDLE newfocus); //Non-void section that updates focus vessel in every function
	bool sethelpsystem(bool thelpsystem) {helpsystem=thelpsystem;};
	bool fliphelpsystem(){helpsystem=!helpsystem;};
	static bool getrenderviewport(){return renderviewportopen;};
	static void setrenderviewport(bool temp){renderviewportopen=temp;};
	static void deletenonactivetransxstate();
	void setmfdactive(bool temp){mfdactive=temp;};
	

	//double debug;//used for debug purposes

private:
	bool initfunctions();
	bool valid;
	bool helpsystem;//On or off
	bool mfdactive;
	static bool renderviewportopen;
	UINT mfdid;//Number of MFD position
	class TransxMFD *mfdpointer; //Pointer to MFD which currently uses this mfdstate
	int mfdstate;
	int oldmfdstate;
	//int lastinitialisedmfdstate;
	class TransXFunction *functionlist[NUMFUNCTIONS];//List of functions
	class TransXFunction *currfunction;//Current function
	static transxstate *mfdstatelist[20];//List of up to 20 transxstates(!)
	static bool statelistinitflag;//Has the list been initialised?
};


#endif